Memcached::appendByKey
Memcached::casByKey
Memcached
PHP Manual

# Memcached::cas

(PECL memcached >= 0.1.0)

Memcached::cas — Compare and swap an item

### 설명

public bool Memcached::cas ( double `$cas_token` , string `$key` , mixed `$value` [, int `$expiration` ] )

Memcached::cas() performs a "check and set" operation, so that the item will be stored only if no other client has updated it since it was last fetched by this client. The check is done via the `cas_token` parameter which is a unique 64-bit value assigned to the existing item by memcache. See the documentation for Memcached::get* methods for how to obtain this token. Note that the token is represented as a double due to the limitations of PHP's integer space.

### 인수

`cas_token`

  Unique value associated with the existing item. Generated by memcache.

`key`

  값을 저장할 키.

`value`

  저장할 값.

`expiration`

  만료 시간, 기본값은 0. 자세한 정보는 만료 시간을 참고하십시오.

### 반환값

성공할 경우 `TRUE`를, 실패할 경우 `FALSE`를 반환합니다. The Memcached::getResultCode will return `Memcached::RES_DATA_EXISTS` if the item you are trying to store has been modified since you last fetched it.

### 예제

Example #1 Memcached::cas() example

`<?php
$m = new Memcached();
$m->addServer('localhost', 11211);
do {
/* fetch IP list and its token */
$ips = $m->get('ip_block', null, $cas);
/* if list doesn't exist yet, create it and do
an atomic add which will fail if someone else already added it */
if ($m->getResultCode() == Memcached::RES_NOTFOUND) {
$ips = array($_SERVER['REMOTE_ADDR']);
$m->add('ip_block', $ips);
/* otherwise, add IP to the list and store via compare-and-swap
with the token, which will fail if someone else updated the list */
} else {
$ips[] = $_SERVER['REMOTE_ADDR'];
$m->cas($cas, 'ip_block', $ips);
}
} while ($m->getResultCode() != Memcached::RES_SUCCESS);
?>`

### 참고

- Memcached::casByKey - Compare and swap an item on a specific server

Memcached::appendByKey
Memcached::casByKey
Memcached
PHP Manual